Index: lemon/Makefile.am
===================================================================
--- lemon/Makefile.am	(revision 594)
+++ lemon/Makefile.am	(revision 601)
@@ -13,15 +13,13 @@
 	lemon/lp_base.cc \
 	lemon/lp_skeleton.cc \
-	lemon/random.cc \
+        lemon/random.cc \
 	lemon/bits/windows.cc
 
 
 lemon_libemon_la_CXXFLAGS = \
-	$(AM_CXXFLAGS) \
 	$(GLPK_CFLAGS) \
 	$(CPLEX_CFLAGS) \
 	$(SOPLEX_CXXFLAGS) \
-	$(CLP_CXXFLAGS) \
-	$(CBC_CXXFLAGS)
+	$(CLP_CXXFLAGS)
 
 lemon_libemon_la_LDFLAGS = \
@@ -29,6 +27,5 @@
 	$(CPLEX_LIBS) \
 	$(SOPLEX_LIBS) \
-	$(CLP_LIBS) \
-	$(CBC_LIBS)
+	$(CLP_LIBS)
 
 if HAVE_GLPK
@@ -46,8 +43,4 @@
 if HAVE_CLP
 lemon_libemon_la_SOURCES += lemon/clp.cc
-endif
-
-if HAVE_CBC
-lemon_libemon_la_SOURCES += lemon/cbc.cc
 endif
 
@@ -76,5 +69,4 @@
 	lemon/full_graph.h \
 	lemon/glpk.h \
-	lemon/gomory_hu.h \
 	lemon/graph_to_eps.h \
 	lemon/grid_graph.h \
@@ -90,8 +82,9 @@
 	lemon/list_graph.h \
 	lemon/maps.h \
-	lemon/matching.h \
 	lemon/math.h \
+	lemon/max_matching.h \
 	lemon/min_cost_arborescence.h \
 	lemon/nauty_reader.h \
+	lemon/network_simplex.h \
 	lemon/path.h \
 	lemon/preflow.h \
Index: lemon/adaptors.h
===================================================================
--- lemon/adaptors.h	(revision 579)
+++ lemon/adaptors.h	(revision 519)
@@ -2193,7 +2193,4 @@
     typedef typename ItemSetTraits<DGR, Edge>::ItemNotifier EdgeNotifier;
     EdgeNotifier& notifier(Edge) const { return _digraph->notifier(Edge()); }
-    
-    typedef EdgeNotifier ArcNotifier;
-    ArcNotifier& notifier(Arc) const { return _digraph->notifier(Edge()); }
 
   protected:
@@ -2258,8 +2255,7 @@
     /// This map adaptor class adapts two arc maps of the underlying
     /// digraph to get an arc map of the undirected graph.
-    /// Its value type is inherited from the first arc map type (\c FW).
-    /// \tparam FW The type of the "foward" arc map.
-    /// \tparam BK The type of the "backward" arc map.
-    template <typename FW, typename BK>
+    /// Its value type is inherited from the first arc map type
+    /// (\c %ForwardMap).
+    template <typename ForwardMap, typename BackwardMap>
     class CombinedArcMap {
     public:
@@ -2268,15 +2264,15 @@
       typedef typename Parent::Arc Key;
       /// The value type of the map
-      typedef typename FW::Value Value;
-
-      typedef typename MapTraits<FW>::ReferenceMapTag ReferenceMapTag;
-
-      typedef typename MapTraits<FW>::ReturnValue ReturnValue;
-      typedef typename MapTraits<FW>::ConstReturnValue ConstReturnValue;
-      typedef typename MapTraits<FW>::ReturnValue Reference;
-      typedef typename MapTraits<FW>::ConstReturnValue ConstReference;
+      typedef typename ForwardMap::Value Value;
+
+      typedef typename MapTraits<ForwardMap>::ReferenceMapTag ReferenceMapTag;
+
+      typedef typename MapTraits<ForwardMap>::ReturnValue ReturnValue;
+      typedef typename MapTraits<ForwardMap>::ConstReturnValue ConstReturnValue;
+      typedef typename MapTraits<ForwardMap>::ReturnValue Reference;
+      typedef typename MapTraits<ForwardMap>::ConstReturnValue ConstReference;
 
       /// Constructor
-      CombinedArcMap(FW& forward, BK& backward)
+      CombinedArcMap(ForwardMap& forward, BackwardMap& backward)
         : _forward(&forward), _backward(&backward) {}
 
@@ -2310,6 +2306,6 @@
     protected:
 
-      FW* _forward;
-      BK* _backward;
+      ForwardMap* _forward;
+      BackwardMap* _backward;
 
     };
@@ -2318,26 +2314,29 @@
     ///
     /// This function just returns a combined arc map.
-    template <typename FW, typename BK>
-    static CombinedArcMap<FW, BK>
-    combinedArcMap(FW& forward, BK& backward) {
-      return CombinedArcMap<FW, BK>(forward, backward);
-    }
-
-    template <typename FW, typename BK>
-    static CombinedArcMap<const FW, BK>
-    combinedArcMap(const FW& forward, BK& backward) {
-      return CombinedArcMap<const FW, BK>(forward, backward);
-    }
-
-    template <typename FW, typename BK>
-    static CombinedArcMap<FW, const BK>
-    combinedArcMap(FW& forward, const BK& backward) {
-      return CombinedArcMap<FW, const BK>(forward, backward);
-    }
-
-    template <typename FW, typename BK>
-    static CombinedArcMap<const FW, const BK>
-    combinedArcMap(const FW& forward, const BK& backward) {
-      return CombinedArcMap<const FW, const BK>(forward, backward);
+    template <typename ForwardMap, typename BackwardMap>
+    static CombinedArcMap<ForwardMap, BackwardMap>
+    combinedArcMap(ForwardMap& forward, BackwardMap& backward) {
+      return CombinedArcMap<ForwardMap, BackwardMap>(forward, backward);
+    }
+
+    template <typename ForwardMap, typename BackwardMap>
+    static CombinedArcMap<const ForwardMap, BackwardMap>
+    combinedArcMap(const ForwardMap& forward, BackwardMap& backward) {
+      return CombinedArcMap<const ForwardMap,
+        BackwardMap>(forward, backward);
+    }
+
+    template <typename ForwardMap, typename BackwardMap>
+    static CombinedArcMap<ForwardMap, const BackwardMap>
+    combinedArcMap(ForwardMap& forward, const BackwardMap& backward) {
+      return CombinedArcMap<ForwardMap,
+        const BackwardMap>(forward, backward);
+    }
+
+    template <typename ForwardMap, typename BackwardMap>
+    static CombinedArcMap<const ForwardMap, const BackwardMap>
+    combinedArcMap(const ForwardMap& forward, const BackwardMap& backward) {
+      return CombinedArcMap<const ForwardMap,
+        const BackwardMap>(forward, backward);
     }
 
@@ -3408,8 +3407,7 @@
     /// This map adaptor class adapts two node maps of the original digraph
     /// to get a node map of the split digraph.
-    /// Its value type is inherited from the first node map type (\c IN).
-    /// \tparam IN The type of the node map for the in-nodes. 
-    /// \tparam OUT The type of the node map for the out-nodes.
-    template <typename IN, typename OUT>
+    /// Its value type is inherited from the first node map type
+    /// (\c InNodeMap).
+    template <typename InNodeMap, typename OutNodeMap>
     class CombinedNodeMap {
     public:
@@ -3418,14 +3416,14 @@
       typedef Node Key;
       /// The value type of the map
-      typedef typename IN::Value Value;
-
-      typedef typename MapTraits<IN>::ReferenceMapTag ReferenceMapTag;
-      typedef typename MapTraits<IN>::ReturnValue ReturnValue;
-      typedef typename MapTraits<IN>::ConstReturnValue ConstReturnValue;
-      typedef typename MapTraits<IN>::ReturnValue Reference;
-      typedef typename MapTraits<IN>::ConstReturnValue ConstReference;
+      typedef typename InNodeMap::Value Value;
+
+      typedef typename MapTraits<InNodeMap>::ReferenceMapTag ReferenceMapTag;
+      typedef typename MapTraits<InNodeMap>::ReturnValue ReturnValue;
+      typedef typename MapTraits<InNodeMap>::ConstReturnValue ConstReturnValue;
+      typedef typename MapTraits<InNodeMap>::ReturnValue Reference;
+      typedef typename MapTraits<InNodeMap>::ConstReturnValue ConstReference;
 
       /// Constructor
-      CombinedNodeMap(IN& in_map, OUT& out_map)
+      CombinedNodeMap(InNodeMap& in_map, OutNodeMap& out_map)
         : _in_map(in_map), _out_map(out_map) {}
 
@@ -3459,6 +3457,6 @@
     private:
 
-      IN& _in_map;
-      OUT& _out_map;
+      InNodeMap& _in_map;
+      OutNodeMap& _out_map;
 
     };
@@ -3468,26 +3466,27 @@
     ///
     /// This function just returns a combined node map.
-    template <typename IN, typename OUT>
-    static CombinedNodeMap<IN, OUT>
-    combinedNodeMap(IN& in_map, OUT& out_map) {
-      return CombinedNodeMap<IN, OUT>(in_map, out_map);
-    }
-
-    template <typename IN, typename OUT>
-    static CombinedNodeMap<const IN, OUT>
-    combinedNodeMap(const IN& in_map, OUT& out_map) {
-      return CombinedNodeMap<const IN, OUT>(in_map, out_map);
-    }
-
-    template <typename IN, typename OUT>
-    static CombinedNodeMap<IN, const OUT>
-    combinedNodeMap(IN& in_map, const OUT& out_map) {
-      return CombinedNodeMap<IN, const OUT>(in_map, out_map);
-    }
-
-    template <typename IN, typename OUT>
-    static CombinedNodeMap<const IN, const OUT>
-    combinedNodeMap(const IN& in_map, const OUT& out_map) {
-      return CombinedNodeMap<const IN, const OUT>(in_map, out_map);
+    template <typename InNodeMap, typename OutNodeMap>
+    static CombinedNodeMap<InNodeMap, OutNodeMap>
+    combinedNodeMap(InNodeMap& in_map, OutNodeMap& out_map) {
+      return CombinedNodeMap<InNodeMap, OutNodeMap>(in_map, out_map);
+    }
+
+    template <typename InNodeMap, typename OutNodeMap>
+    static CombinedNodeMap<const InNodeMap, OutNodeMap>
+    combinedNodeMap(const InNodeMap& in_map, OutNodeMap& out_map) {
+      return CombinedNodeMap<const InNodeMap, OutNodeMap>(in_map, out_map);
+    }
+
+    template <typename InNodeMap, typename OutNodeMap>
+    static CombinedNodeMap<InNodeMap, const OutNodeMap>
+    combinedNodeMap(InNodeMap& in_map, const OutNodeMap& out_map) {
+      return CombinedNodeMap<InNodeMap, const OutNodeMap>(in_map, out_map);
+    }
+
+    template <typename InNodeMap, typename OutNodeMap>
+    static CombinedNodeMap<const InNodeMap, const OutNodeMap>
+    combinedNodeMap(const InNodeMap& in_map, const OutNodeMap& out_map) {
+      return CombinedNodeMap<const InNodeMap,
+        const OutNodeMap>(in_map, out_map);
     }
 
@@ -3497,8 +3496,7 @@
     /// This map adaptor class adapts an arc map and a node map of the
     /// original digraph to get an arc map of the split digraph.
-    /// Its value type is inherited from the original arc map type (\c AM).
-    /// \tparam AM The type of the arc map.
-    /// \tparam NM the type of the node map.
-    template <typename AM, typename NM>
+    /// Its value type is inherited from the original arc map type
+    /// (\c ArcMap).
+    template <typename ArcMap, typename NodeMap>
     class CombinedArcMap {
     public:
@@ -3507,14 +3505,14 @@
       typedef Arc Key;
       /// The value type of the map
-      typedef typename AM::Value Value;
-
-      typedef typename MapTraits<AM>::ReferenceMapTag ReferenceMapTag;
-      typedef typename MapTraits<AM>::ReturnValue ReturnValue;
-      typedef typename MapTraits<AM>::ConstReturnValue ConstReturnValue;
-      typedef typename MapTraits<AM>::ReturnValue Reference;
-      typedef typename MapTraits<AM>::ConstReturnValue ConstReference;
+      typedef typename ArcMap::Value Value;
+
+      typedef typename MapTraits<ArcMap>::ReferenceMapTag ReferenceMapTag;
+      typedef typename MapTraits<ArcMap>::ReturnValue ReturnValue;
+      typedef typename MapTraits<ArcMap>::ConstReturnValue ConstReturnValue;
+      typedef typename MapTraits<ArcMap>::ReturnValue Reference;
+      typedef typename MapTraits<ArcMap>::ConstReturnValue ConstReference;
 
       /// Constructor
-      CombinedArcMap(AM& arc_map, NM& node_map)
+      CombinedArcMap(ArcMap& arc_map, NodeMap& node_map)
         : _arc_map(arc_map), _node_map(node_map) {}
 
@@ -3547,8 +3545,6 @@
 
     private:
-
-      AM& _arc_map;
-      NM& _node_map;
-
+      ArcMap& _arc_map;
+      NodeMap& _node_map;
     };
 
Index: lemon/bin_heap.h
===================================================================
--- lemon/bin_heap.h	(revision 584)
+++ lemon/bin_heap.h	(revision 440)
@@ -34,28 +34,27 @@
   ///\brief A Binary Heap implementation.
   ///
-  ///This class implements the \e binary \e heap data structure. 
-  /// 
-  ///A \e heap is a data structure for storing items with specified values
-  ///called \e priorities in such a way that finding the item with minimum
-  ///priority is efficient. \c Comp specifies the ordering of the priorities.
-  ///In a heap one can change the priority of an item, add or erase an
-  ///item, etc.
+  ///This class implements the \e binary \e heap data structure. A \e heap
+  ///is a data structure for storing items with specified values called \e
+  ///priorities in such a way that finding the item with minimum priority is
+  ///efficient. \c Compare specifies the ordering of the priorities. In a heap
+  ///one can change the priority of an item, add or erase an item, etc.
   ///
-  ///\tparam PR Type of the priority of the items.
-  ///\tparam IM A read and writable item map with int values, used internally
+  ///\tparam _Prio Type of the priority of the items.
+  ///\tparam _ItemIntMap A read and writable Item int map, used internally
   ///to handle the cross references.
-  ///\tparam Comp A functor class for the ordering of the priorities.
-  ///The default is \c std::less<PR>.
+  ///\tparam _Compare A class for the ordering of the priorities. The
+  ///default is \c std::less<_Prio>.
   ///
   ///\sa FibHeap
   ///\sa Dijkstra
-  template <typename PR, typename IM, typename Comp = std::less<PR> >
+  template <typename _Prio, typename _ItemIntMap,
+            typename _Compare = std::less<_Prio> >
   class BinHeap {
 
   public:
     ///\e
-    typedef IM ItemIntMap;
-    ///\e
-    typedef PR Prio;
+    typedef _ItemIntMap ItemIntMap;
+    ///\e
+    typedef _Prio Prio;
     ///\e
     typedef typename ItemIntMap::Key Item;
@@ -63,5 +62,5 @@
     typedef std::pair<Item,Prio> Pair;
     ///\e
-    typedef Comp Compare;
+    typedef _Compare Compare;
 
     /// \brief Type to represent the items states.
@@ -71,16 +70,16 @@
     /// heap's point of view, but may be useful to the user.
     ///
-    /// The item-int map must be initialized in such way that it assigns
-    /// \c PRE_HEAP (<tt>-1</tt>) to any element to be put in the heap.
+    /// The ItemIntMap \e should be initialized in such way that it maps
+    /// PRE_HEAP (-1) to any element to be put in the heap...
     enum State {
-      IN_HEAP = 0,    ///< = 0.
-      PRE_HEAP = -1,  ///< = -1.
-      POST_HEAP = -2  ///< = -2.
+      IN_HEAP = 0,
+      PRE_HEAP = -1,
+      POST_HEAP = -2
     };
 
   private:
-    std::vector<Pair> _data;
-    Compare _comp;
-    ItemIntMap &_iim;
+    std::vector<Pair> data;
+    Compare comp;
+    ItemIntMap &iim;
 
   public:
@@ -88,19 +87,19 @@
     ///
     /// The constructor.
-    /// \param map should be given to the constructor, since it is used
-    /// internally to handle the cross references. The value of the map
-    /// must be \c PRE_HEAP (<tt>-1</tt>) for every item.
-    explicit BinHeap(ItemIntMap &map) : _iim(map) {}
-
-    /// \brief The constructor.
-    ///
-    /// The constructor.
-    /// \param map should be given to the constructor, since it is used
+    /// \param _iim should be given to the constructor, since it is used
     /// internally to handle the cross references. The value of the map
     /// should be PRE_HEAP (-1) for each element.
-    ///
-    /// \param comp The comparator function object.
-    BinHeap(ItemIntMap &map, const Compare &comp)
-      : _iim(map), _comp(comp) {}
+    explicit BinHeap(ItemIntMap &_iim) : iim(_iim) {}
+
+    /// \brief The constructor.
+    ///
+    /// The constructor.
+    /// \param _iim should be given to the constructor, since it is used
+    /// internally to handle the cross references. The value of the map
+    /// should be PRE_HEAP (-1) for each element.
+    ///
+    /// \param _comp The comparator function object.
+    BinHeap(ItemIntMap &_iim, const Compare &_comp)
+      : iim(_iim), comp(_comp) {}
 
 
@@ -108,10 +107,10 @@
     ///
     /// \brief Returns the number of items stored in the heap.
-    int size() const { return _data.size(); }
+    int size() const { return data.size(); }
 
     /// \brief Checks if the heap stores no items.
     ///
     /// Returns \c true if and only if the heap stores no items.
-    bool empty() const { return _data.empty(); }
+    bool empty() const { return data.empty(); }
 
     /// \brief Make empty this heap.
@@ -122,5 +121,5 @@
     /// each item to \c PRE_HEAP.
     void clear() {
-      _data.clear();
+      data.clear();
     }
 
@@ -130,11 +129,11 @@
     static int second_child(int i) { return 2*i+2; }
     bool less(const Pair &p1, const Pair &p2) const {
-      return _comp(p1.second, p2.second);
+      return comp(p1.second, p2.second);
     }
 
     int bubble_up(int hole, Pair p) {
       int par = parent(hole);
-      while( hole>0 && less(p,_data[par]) ) {
-        move(_data[par],hole);
+      while( hole>0 && less(p,data[par]) ) {
+        move(data[par],hole);
         hole = par;
         par = parent(hole);
@@ -147,16 +146,16 @@
       int child = second_child(hole);
       while(child < length) {
-        if( less(_data[child-1], _data[child]) ) {
+        if( less(data[child-1], data[child]) ) {
           --child;
         }
-        if( !less(_data[child], p) )
+        if( !less(data[child], p) )
           goto ok;
-        move(_data[child], hole);
+        move(data[child], hole);
         hole = child;
         child = second_child(hole);
       }
       child--;
-      if( child<length && less(_data[child], p) ) {
-        move(_data[child], hole);
+      if( child<length && less(data[child], p) ) {
+        move(data[child], hole);
         hole=child;
       }
@@ -167,6 +166,6 @@
 
     void move(const Pair &p, int i) {
-      _data[i] = p;
-      _iim.set(p.first, i);
+      data[i] = p;
+      iim.set(p.first, i);
     }
 
@@ -177,6 +176,6 @@
     /// \param p The pair to insert.
     void push(const Pair &p) {
-      int n = _data.size();
-      _data.resize(n+1);
+      int n = data.size();
+      data.resize(n+1);
       bubble_up(n, p);
     }
@@ -195,5 +194,5 @@
     /// \pre The heap must be nonempty.
     Item top() const {
-      return _data[0].first;
+      return data[0].first;
     }
 
@@ -203,5 +202,5 @@
     /// \pre The heap must be nonempty.
     Prio prio() const {
-      return _data[0].second;
+      return data[0].second;
     }
 
@@ -212,10 +211,10 @@
     /// \pre The heap must be non-empty.
     void pop() {
-      int n = _data.size()-1;
-      _iim.set(_data[0].first, POST_HEAP);
+      int n = data.size()-1;
+      iim.set(data[0].first, POST_HEAP);
       if (n > 0) {
-        bubble_down(0, _data[n], n);
-      }
-      _data.pop_back();
+        bubble_down(0, data[n], n);
+      }
+      data.pop_back();
     }
 
@@ -226,13 +225,13 @@
     /// \pre The item should be in the heap.
     void erase(const Item &i) {
-      int h = _iim[i];
-      int n = _data.size()-1;
-      _iim.set(_data[h].first, POST_HEAP);
+      int h = iim[i];
+      int n = data.size()-1;
+      iim.set(data[h].first, POST_HEAP);
       if( h < n ) {
-        if ( bubble_up(h, _data[n]) == h) {
-          bubble_down(h, _data[n], n);
+        if ( bubble_up(h, data[n]) == h) {
+          bubble_down(h, data[n], n);
         }
       }
-      _data.pop_back();
+      data.pop_back();
     }
 
@@ -241,9 +240,9 @@
     ///
     /// This function returns the priority of item \c i.
-    /// \param i The item.
     /// \pre \c i must be in the heap.
+    /// \param i The item.
     Prio operator[](const Item &i) const {
-      int idx = _iim[i];
-      return _data[idx].second;
+      int idx = iim[i];
+      return data[idx].second;
     }
 
@@ -256,13 +255,13 @@
     /// \param p The priority.
     void set(const Item &i, const Prio &p) {
-      int idx = _iim[i];
+      int idx = iim[i];
       if( idx < 0 ) {
         push(i,p);
       }
-      else if( _comp(p, _data[idx].second) ) {
+      else if( comp(p, data[idx].second) ) {
         bubble_up(idx, Pair(i,p));
       }
       else {
-        bubble_down(idx, Pair(i,p), _data.size());
+        bubble_down(idx, Pair(i,p), data.size());
       }
     }
@@ -271,10 +270,10 @@
     ///
     /// This method decreases the priority of item \c i to \c p.
-    /// \param i The item.
-    /// \param p The priority.
     /// \pre \c i must be stored in the heap with priority at least \c
     /// p relative to \c Compare.
+    /// \param i The item.
+    /// \param p The priority.
     void decrease(const Item &i, const Prio &p) {
-      int idx = _iim[i];
+      int idx = iim[i];
       bubble_up(idx, Pair(i,p));
     }
@@ -283,11 +282,11 @@
     ///
     /// This method sets the priority of item \c i to \c p.
-    /// \param i The item.
-    /// \param p The priority.
     /// \pre \c i must be stored in the heap with priority at most \c
     /// p relative to \c Compare.
+    /// \param i The item.
+    /// \param p The priority.
     void increase(const Item &i, const Prio &p) {
-      int idx = _iim[i];
-      bubble_down(idx, Pair(i,p), _data.size());
+      int idx = iim[i];
+      bubble_down(idx, Pair(i,p), data.size());
     }
 
@@ -301,5 +300,5 @@
     /// \param i The item.
     State state(const Item &i) const {
-      int s = _iim[i];
+      int s = iim[i];
       if( s>=0 )
         s=0;
@@ -321,5 +320,5 @@
           erase(i);
         }
-        _iim[i] = st;
+        iim[i] = st;
         break;
       case IN_HEAP:
@@ -335,8 +334,8 @@
     /// with the same prioriority as prevoiusly the \c i item.
     void replace(const Item& i, const Item& j) {
-      int idx = _iim[i];
-      _iim.set(i, _iim[j]);
-      _iim.set(j, idx);
-      _data[idx].first = j;
+      int idx = iim[i];
+      iim.set(i, iim[j]);
+      iim.set(j, idx);
+      data[idx].first = j;
     }
 
Index: lemon/bits/edge_set_extender.h
===================================================================
--- lemon/bits/edge_set_extender.h	(revision 559)
+++ lemon/bits/edge_set_extender.h	(revision 519)
@@ -25,12 +25,12 @@
 #include <lemon/bits/map_extender.h>
 
-//\ingroup digraphbits
-//\file
-//\brief Extenders for the arc set types
+///\ingroup digraphbits
+///\file
+///\brief Extenders for the arc set types
 namespace lemon {
 
-  // \ingroup digraphbits
-  //
-  // \brief Extender for the ArcSets
+  /// \ingroup digraphbits
+  ///
+  /// \brief Extender for the ArcSets
   template <typename Base>
   class ArcSetExtender : public Base {
@@ -73,5 +73,5 @@
     // Alteration notifier extensions
 
-    // The arc observer registry.
+    /// The arc observer registry.
     typedef AlterationNotifier<ArcSetExtender, Arc> ArcNotifier;
 
@@ -84,5 +84,7 @@
     using Parent::notifier;
 
-    // Gives back the arc alteration notifier.
+    /// \brief Gives back the arc alteration notifier.
+    ///
+    /// Gives back the arc alteration notifier.
     ArcNotifier& notifier(Arc) const {
       return arc_notifier;
@@ -184,28 +186,28 @@
     };
 
-    // \brief Base node of the iterator
-    //
-    // Returns the base node (ie. the source in this case) of the iterator
+    /// \brief Base node of the iterator
+    ///
+    /// Returns the base node (ie. the source in this case) of the iterator
     Node baseNode(const OutArcIt &e) const {
       return Parent::source(static_cast<const Arc&>(e));
     }
-    // \brief Running node of the iterator
-    //
-    // Returns the running node (ie. the target in this case) of the
-    // iterator
+    /// \brief Running node of the iterator
+    ///
+    /// Returns the running node (ie. the target in this case) of the
+    /// iterator
     Node runningNode(const OutArcIt &e) const {
       return Parent::target(static_cast<const Arc&>(e));
     }
 
-    // \brief Base node of the iterator
-    //
-    // Returns the base node (ie. the target in this case) of the iterator
+    /// \brief Base node of the iterator
+    ///
+    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &e) const {
       return Parent::target(static_cast<const Arc&>(e));
     }
-    // \brief Running node of the iterator
-    //
-    // Returns the running node (ie. the source in this case) of the
-    // iterator
+    /// \brief Running node of the iterator
+    ///
+    /// Returns the running node (ie. the source in this case) of the
+    /// iterator
     Node runningNode(const InArcIt &e) const {
       return Parent::source(static_cast<const Arc&>(e));
@@ -270,7 +272,7 @@
 
 
-  // \ingroup digraphbits
-  //
-  // \brief Extender for the EdgeSets
+  /// \ingroup digraphbits
+  ///
+  /// \brief Extender for the EdgeSets
   template <typename Base>
   class EdgeSetExtender : public Base {
@@ -491,41 +493,41 @@
     };
 
-    // \brief Base node of the iterator
-    //
-    // Returns the base node (ie. the source in this case) of the iterator
+    /// \brief Base node of the iterator
+    ///
+    /// Returns the base node (ie. the source in this case) of the iterator
     Node baseNode(const OutArcIt &e) const {
       return Parent::source(static_cast<const Arc&>(e));
     }
-    // \brief Running node of the iterator
-    //
-    // Returns the running node (ie. the target in this case) of the
-    // iterator
+    /// \brief Running node of the iterator
+    ///
+    /// Returns the running node (ie. the target in this case) of the
+    /// iterator
     Node runningNode(const OutArcIt &e) const {
       return Parent::target(static_cast<const Arc&>(e));
     }
 
-    // \brief Base node of the iterator
-    //
-    // Returns the base node (ie. the target in this case) of the iterator
+    /// \brief Base node of the iterator
+    ///
+    /// Returns the base node (ie. the target in this case) of the iterator
     Node baseNode(const InArcIt &e) const {
       return Parent::target(static_cast<const Arc&>(e));
     }
-    // \brief Running node of the iterator
-    //
-    // Returns the running node (ie. the source in this case) of the
-    // iterator
+    /// \brief Running node of the iterator
+    ///
+    /// Returns the running node (ie. the source in this case) of the
+    /// iterator
     Node runningNode(const InArcIt &e) const {
       return Parent::source(static_cast<const Arc&>(e));
     }
 
-    // Base node of the iterator
-    //
-    // Returns the base node of the iterator
+    /// Base node of the iterator
+    ///
+    /// Returns the base node of the iterator
     Node baseNode(const IncEdgeIt &e) const {
       return e.direction ? u(e) : v(e);
     }
-    // Running node of the iterator
-    //
-    // Returns the running node of the iterator
+    /// Running node of the iterator
+    ///
+    /// Returns the running node of the iterator
     Node runningNode(const IncEdgeIt &e) const {
       return e.direction ? v(e) : u(e);
Index: lemon/bits/graph_adaptor_extender.h
===================================================================
--- lemon/bits/graph_adaptor_extender.h	(revision 580)
+++ lemon/bits/graph_adaptor_extender.h	(revision 455)
@@ -22,4 +22,6 @@
 #include <lemon/core.h>
 #include <lemon/error.h>
+
+#include <lemon/bits/default_map.h>
 
 namespace lemon {
Index: lemon/bits/map_extender.h
===================================================================
--- lemon/bits/map_extender.h	(revision 580)
+++ lemon/bits/map_extender.h	(revision 440)
@@ -48,6 +48,4 @@
     typedef typename Parent::Key Key;
     typedef typename Parent::Value Value;
-    typedef typename Parent::Reference Reference;
-    typedef typename Parent::ConstReference ConstReference;
 
     class MapIt;
@@ -190,6 +188,4 @@
     typedef typename Parent::Key Key;
     typedef typename Parent::Value Value;
-    typedef typename Parent::Reference Reference;
-    typedef typename Parent::ConstReference ConstReference;
 
     class MapIt;
